
; *****************************************************************************
;
;                              EGACSmin
;              Instalace eskch znak na displej EGA/VGA Mini
;
; *****************************************************************************

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   jmp       Instal                   ; instalace programu

                                            ; identifikan text
Ident    db        'EGACSmin V2.42'
Ident0   label     byte

SegRez   dw        0                        ; segment rezidentn sti
Old10    dd        0                        ; pvodn adresa obsluhy INT 10h

FontTab  db        1                        ; slo tabulky font
                                            ;   0=bez font
                                            ;   1=Kamenickch
                                            ;   2=Latin 2
                                            ;   3=KOI 8

AdrSt8   dd        0                        ; adresa standardnho fontu 8x8
AdrSt14  dd        0                        ; adresa standardnho fontu 8x14
AdrSt16  dd        0                        ; adresa stand. fontu 8x16
AdrSt19  dd        0                        ; adresa stand. fontu 8x19
AdrSt190 dd        0                        ; adresa stand. fontu 8x19 zvraz.

RegMap   db        0                        ; nastaven registru pro mapovn

; -----------------------------------------------------------------------------
;        voln pvodn obsluhy INT 10h
; -----------------------------------------------------------------------------

Int10I   PROC      NEAR

         pushf                              ; simulace isntrukce INT xx
         call      dword ptr cs:[Old10]     ; nastaven novho videomdu
         ret

Int10I   ENDP

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 10h
; -----------------------------------------------------------------------------

Int10    PROC      FAR

; ------ test, zda je dotaz na instalaci

         cmp       ah,12h                   ; funkce dotazu na instalaci ?
         jne       Int101                   ; nen dotaz na instalaci
         cmp       bx,3e10h                 ; je dotaz na instalaci ?
         jne       Int102                   ; nen identifikace dotazu

; ------ oven, zda piel poadavek opravdu od EGACSmin

         push      si
         push      di
         push      cx
         push      ds
         cld
         push      cs
         pop       ds                       ; segment tohoto modulu
         mov       si,offset Ident          ; zatek identifikanho textu
         mov       di,si                    ; adresa identifikanho textu
         mov       cx,offset(Ident0-Ident)  ; dlka identifikanho textu
         repe      cmpsb                    ; je to tento program ?
         jne       Int100                   ; nen to tento program
         mov       es:[SegRez],cs           ; segment rezidentnho modulu
Int100:  pop       ds
         pop       cx
         pop       di
         pop       si

; ------ rozlien, zda se maj peinstalovat fonty

Int101:  or        ah,ah                    ; je nastaven mdu displeje ?
         jz        int103                   ; je nastaven videomdu
         cmp       ah,11h                   ; je sluba obsluhy font ?
         jne       int102                   ; nen operace s fonty

; ------ kontrola, zda je nastaven font sluby 11h

         test      al,0fh                   ; jsou uiv. fonty nebo informace ?
         jz        Int102                   ; uivatelsk fonty nebo informace
         cmp       al,3                     ; je nastaven bloku font ?
         jne       Int103                   ; nen nastaven bloku
;         mov       bl,0
Int102:  jmp       dword ptr cs:[Old10]     ; skok na pvodn obsluhu INT 10h

; ------ fonty se peinstaluj

Int103:  call      Int10I                   ; voln pvodn poadovan funkce

;         push      ax
;         push      dx
;         mov       dx,3c4h
;         mov       al,3
;         out       dx,al
;         inc       dx
;         mov       al,0
;         out       dx,al
;         pop       dx
;         pop       ax

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ stanoven adresy definin tabulky font

         cmp       byte ptr cs:[FontTab],0  ; je njak font ?
         je        Int109                   ; funkce je vypnuta
         mov       bp,offset TabKoi         ; tabulka definice fontu

; ------ kontrola, zda je textov videomd

         xor       ax,ax                    ; AX <- 0
         mov       ds,ax                    ; DS <- 0 datov segment BIOS
         mov       al,ds:[449h]             ; aktuln videomd
         and       al,7fh                   ; zruen pznaku nemazn displeje
         mov       ah,0eh                   ; registr mapovn pro CGA
         cmp       al,3                     ; je textov videomd CGA ?
         jbe       Int104                   ; je textov md CGA - OK
         cmp       al,85                    ; videomd "Paradise VGA" ?
         je        Int104                   ; textov videomd OK
         cmp       al,7                     ; je videomd MDA ?
         jne       Int109                   ; nen textov videomd
         mov       ah,0ah                   ; registr mapovn pro MDA
Int104:  mov       cs:[RegMap],ah           ; schova registru pro mapovn

; ------ nastaven videoadie do reimu definice znak

         call      InitRegF                 ; inicializace registr pro fonty

; ------ stanoven adresy fontu podle potu linek na znak

         mov       cx,ds:[485h]             ; poet linek na znak
         mov       bx,offset Font8          ; font 8x8
         lds       si,cs:[AdrSt8]           ; standardn font 8x8
         cmp       cx,8                     ; je font 8x8 ?
         je        Int105                   ; je font 8x8
         mov       bx,offset Font14         ; font 8x14 a 8x16
         lds       si,cs:[Adrst14]          ; standardn font 8x14
         cmp       cx,14
         je        Int105                   ; je font 8x14
         lds       si,cs:[Adrst16]          ; standardn font 8x16
         cmp       cx,16
         je        Int105
         lds       si,cs:[Adrst19]          ; standardn font 8x19
         cmp       cx,19
         jne       Int106                   ; nen ani font 8x16

; ------ pedefinovn font

Int105:  mov       word ptr cs:[PrevCh44+2],0 ; zkladn blok
         push      bp
         call      Defin                    ; definovn nrodnch font
         pop       bp
         cmp       cx,19
         jne       Int106
         lds       si,cs:[Adrst190]         ; font 8x19 zvraznn
         mov       word ptr cs:[PrevCh44+2],32*256
         call      Defin

; ------ zptn nastaven videomdu

Int106:  call      InitRegT                 ; inicializace registr pro text

; ------ nvrat registr

Int109:  pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         iret

Int10    ENDP

; -----------------------------------------------------------------------------
;        pedefinovn nrodnch font
; -----------------------------------------------------------------------------
; VSTUP: CS:BP=definin tabulka kdu
;        CS:BX=vlastn fonty
;        CX=poet linek na znak
;        DS:SI=standardn fonty
; -----------------------------------------------------------------------------

Defin    PROC      NEAR

         mov       ax,0a000h                ; segment videopamti
         mov       es,ax                    ; segment videopamti
         mov       dh,80h                   ; poten ukazatel znak

; ------ test konce tabulky

Tabel1:  mov       ax,cs:[bp]               ; definice z tabulky
         add       bp,2                     ; zven ukazatele
         or        ax,ax                    ; je konec tabulky ?
         jnz       Tabel2                   ; nen jet konec tabulky
         ret

; ------ proveden skoku

Tabel2:  push      ax
         and       al,7                     ; dlka skoku
         add       dh,al                    ; zven sla znaku
         pop       ax

; ------ pevod znaku

         shr       al,1
         shr       al,1
         shr       al,1                     ; slo fontu (0 a 31)
         mov       dl,ah                    ; standardn znak
         call      PrevCh                   ; pevod znaku
         inc       dh                       ; zven ukazatele
         jmp       short Tabel1             ; dal font

Defin    ENDP

; -----------------------------------------------------------------------------
;     Pevod znaku
; -----------------------------------------------------------------------------
; VSTUP: ES=segment videopamti
;        DS:SI=standardn fonty
;        CS:BX=vlastn fonty
;        CX=poet linek na znak
;        DL=standardn znak
;        DH=msto k uloen
;        AL=slo fontu 0 a 31
;        ES=segment k uloen znak
; -----------------------------------------------------------------------------
; znien registry: AX, DI
; -----------------------------------------------------------------------------

PrevCh   PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      si
         cld                                ; smr nahoru

; ------ adresa vlastnho fontu

Prevch0: dec       al
         js        Prevch4                  ; font nalezen
         push      ax
         mov       al,cs:[bx]               ; definice fontu
         inc       bx
         and       ax,0fh                   ; dlka fontu
         add       bx,ax                    ; zven adresy fontu
         pop       ax
         jmp       short Prevch0            ; dal font

; ------ adresa msta uloen znaku ES:DI

Prevch4: mov       al,32                    ; poet bajt na znak ve fontech
         mul       dh                       ; offset ve videopamti
         mov       di,ax                    ; adresa znaku ve videopamti
PrevCh44:add       di,1234h                 ; korekce pro blok

; ------ adresa standardnho fontu DS:SI

         mov       al,cl                    ; poet linek na znak
         mul       dl                       ; offset v tabulce stand. znak
         add       si,ax                    ; adresa v tabulce stand. znak

; ------ poten a koncov linka fontu

         mov       dl,cs:[bx]               ; poten linka a dlka
         inc       bx                       ; zven adresy
         mov       dh,dl                    ; kopie do DH
         and       dl,0fh                   ; DL=dlka 0 a 15
         shr       dh,1
         shr       dh,1
         shr       dh,1
         shr       dh,1                     ; DH=poten linka 0 a 15

; ------ korekce pro fonty 16x8 a 19x8

         cmp       cl,14
         jbe       Prevch5

         cmp       cl,19
         jb        Prevch55
         or        dh,dh
         jz        PrevCh55
         add       dh,2
         cmp       dh,8
         jbe       Prevch55
         inc       dh
Prevch55:cmp       dh,8
         jb        Prevch5                  ; je v horn polovin
         add       dh,2                     ; zven pozice

; ------ korekce hornch linek pro 8x8

Prevch5: or        dl,dl                    ; je njak font ?
         jz        Prevch8                  ; nen dn font - nen korekce
         cmp       dh,4                     ; je font dole ?
         jae       Prevch8                  ; je font dole - nen korekce
         inc       si
         mov       ax,100h                  ; korekce pro font 8x8
         cmp       cl,8                     ; je font 8x8 ?
         je        Prevch7                  ; nen font 8x8
         dec       si
Prevch8: mov       ah,-1                    ; nen korekce pro ostatn znaky

; ------ pevod jednoho znaku

Prevch1: lodsb                              ; bajt standardnho fontu
         dec       ah                       ; korekce pro fonty 8x8
         jnz       Prevch7                  ; nen prvn bajt
         or        al,ds:[si-2]             ; + bajt z pedel linky
Prevch7: dec       dh                       ; ta poten linky
         jns       Prevch2                  ; je pod poten linkou
         dec       dl                       ; ta potu linek
         js        Prevch2                  ; je nad koncovou linkou
         or        al,cs:[bx]               ; slouen s vlatnm znakem

         cmp       byte ptr cs:[PrevCh44+3],0
         je        PrevCh22
         push      dx
         mov       dl,cs:[bx]
         shl       dl,1
         or        al,dl
         pop       dx
Prevch22:

         inc       bx                       ; zven adresy vlastnho fontu
Prevch2: stosb                              ; uloen do videopamti
         loop      Prevch1                  ; dal bajt

; ------ nvrat registr

Prevch3: pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

PrevCh   ENDP

; -----------------------------------------------------------------------------
;     Inicializace registr videokarty na reim definice font
; -----------------------------------------------------------------------------

InitRegF PROC      NEAR

         mov       cl,4                     ; nastaven mapovn pro fonty
         mov       bx,407h                  ; BH=roviny, BL=prokldn
         jmp       short InitReg            ; inicializace registr

InitRegF ENDP

; -----------------------------------------------------------------------------
;        Inicializace registr videokarty na textov videomd
; -----------------------------------------------------------------------------

InitRegT PROC      NEAR

         mov       cl,cs:[RegMap]           ; registr pro mapovn
         mov       bx,303h                  ; BH=roviny, BL=prokldn

InitRegT ENDP

; -----------------------------------------------------------------------------
;        Inicializace registr videokarty
; -----------------------------------------------------------------------------
; VSTUP: BH=nastaven rovin
;        BL=nastaven prokldn
;        CL=nastaven mapovn
; -----------------------------------------------------------------------------
; znien registry: AX, DX
; -----------------------------------------------------------------------------

InitReg  PROC      NEAR

; ------ volba rovin pro zpis (maska)

         mov       dx,3c4h                  ; bzov adresa 03c4h
         mov       al,2
         out       dx,al
         inc       dx
         mov       al,bh                    ; roviny
         out       dx,al
         dec       dx                       ; nastaven rovin pro zpis

; ------ nastav. prokldn bajt sud/lich

         mov       al,4
         out       dx,al
         inc       dx
         mov       al,bl                    ; prokldn
         out       dx,al                    ; nastaven prokldn bajt

; ------ nastaven mapovn videopamti

         mov       dl,0ceh                  ; port 03ceh/03cfh
         mov       al,6
         out       dx,al
         inc       dx
         mov       al,cl                    ; nastaven mapovn
         out       dx,al                    ; registr 6: mapovn videopamti
         ret

InitReg  ENDP

; *****************************************************************************
;                              Tabulky
; *****************************************************************************

font8    label     byte                     ; fonty 8x8
         db        2,0ch,18h                ; carv: rka pro velk psmena
         db        2,0ch,18h                ; carm: rka pro mal psmena
         db        2,3,3                    ; carp: rka po prav stran
         db        2,30h,18h                ; zcarv: zptn rka pro velk ps.
         db        2,30h,18h                ; zcarm: zptn rka pro mal psm.
         db        2,6ch,38h                ; hacv: hek pro velk psmena
         db        2,6ch,38h                ; hacm: hek pro mal psmena
         db        2,5,6                    ; hacp: hek po prav stran
         db        3,10h,28h,10h            ; krov: krouek nad velkm "U"
         db        3,38h,6ch,38h            ; krom: krouek nad malm "u"
         db        1,0feh                   ; strv: stka nad velkm psmenem
         db        32h,30h,0c0h             ; skrl: pekrtnut vlevo
         db        32h,18h,60h              ; skrs: pekrtnut uprosted
         db        12h,6,18h                ; skrp: pekrtnut vpravo
         db        2,66h,0cch               ; dvov: dvojrka nad velkm psm.
         db        2,66h,0cch               ; dvom: dvojrka nad malm psm.
         db        62h,8,0eh                ; patr: patika vpravo
         db        62h,10h,1ch              ; pats: patika uprosted
         db        62h,18h,38h              ; ocap: ocsek uprosted
         db        1,18h                    ; tecv: teka nad velkm psmenem
         db        1,18h                    ; tecm: teka nad malm psmenem
         db        2,0c6h,7ch               ; misv: miska nad velkm psmenem
         db        2,0c6h,7ch               ; mism: miska nad malm psmenem
         db        7,0c6h,7ch,0c6h,0c6h,0c6h,7ch,0c6h ; spc1: rubl
         db        1,66h                    ; dvot: dvojteka
         db        0                        ; nofn: konec tabulky


font14   label     byte                     ; fonty 8x14 a 8x16
         db        2,0ch,18h                ; carv: rka pro velk psmena
         db        13h,0ch,18h,30h          ; carm: rka pro mal psmena
         db        3,3,3,2                  ; carp: rka po prav stran
         db        2,30h,18h                ; zcarv: zptn rka pro velk ps.
         db        13h,30h,18h,0ch          ; zcarm: zptn rka pro mal psm.
         db        3,66h,3ch,18h            ; hacv: hek pro velk psmena
         db        13h,66h,3ch,18h          ; hacm: hek pro mal psmena
         db        3,1bh,0eh,8              ; hacp: hek po prav stran
         db        3,10h,28h,10h            ; krov: krouek nad velkm "U"
         db        13h,38h,6ch,38h          ; krom: krouek nad malm "u"
         db        2,7eh,0c3h               ; strv: stka nad velkm psmenem
         db        52h,30h,0c0h             ; skrl: pekrtnut vlevo
         db        52h,0ch,30h              ; skrs: pekrtnut uprosted
         db        32h,6,18h                ; skrp: pekrtnut vpravo
         db        2,33h,66h                ; dvov: dvojrka nad velkm psm.
         db        22h,33h,66h              ; dvom: dvojrka nad malm psm.
         db        094h,8,8,8,0eh           ; patr: patika vpravo
         db        094h,10h,10h,10h,1ch     ; pats: patika uprosted
         db        0a4h,18h,18h,0ch,38h     ; ocap: ocsek uprosted
         db        2,18h,18h                ; tecv: teka nad velkm psmenem
         db        22h,18h,18h              ; tecm: teka nad malm psmenem
         db        2,0c6h,7ch               ; misv: miska nad velkm psmenem
         db        22h,0c6h,7ch             ; mism: miska nad malm psmenem
         db        47h,0c6h,7ch,0c6h,0c6h,0c6h,7ch,0c6h ; spc1: rubl
         db        1,66h                    ; dvot: dvojteka
         db        0                        ; nofn: konec tabulky

carv     equ       00h                      ; rka pro velk psmena
carm     equ       08h                      ; rka pro mal psmena
carp     equ       10h                      ; rka po prav stran
zcarv    equ       18h                      ; zptn rka pro velk psmena
zcarm    equ       20h                      ; zptn rka pro mal psmena
hacv     equ       28h                      ; hek pro velk psmena
hacm     equ       30h                      ; hek pro mal psmena
hacp     equ       38h                      ; hek po prav stran
krov     equ       40h                      ; krouek nad velkm "U"
krom     equ       48h                      ; krouek nad malm "u"
strv     equ       50h                      ; stka nad velkm psmenem
skrl     equ       58h                      ; pekrnut vlevo
skrs     equ       60h                      ; pekrtnut uprosted
skrp     equ       68h                      ; pekrtnut vpravo
dvov     equ       70h                      ; dvojrka nad velkm psmenem
dvom     equ       78h                      ; dvojrka nad malm psmenem
patr     equ       80h                      ; patika vpravo
pats     equ       88h                      ; patika uprosted
ocap     equ       90h                      ; ocsek uprosted
tecv     equ       98h                      ; teka nad velkm psmenem
tecm     equ       0a0h                     ; teka nad malm psmenem
misv     equ       0a8h                     ; miska nad velkm psmenem
mism     equ       0b0h                     ; miska nad malm psmenem
spc1     equ       0b8h                     ; speciln znak - rubl
dvot     equ       0c0h                     ; dvojteka

nofn     equ       0c8h                     ; konec tabulky


TabKoi   label     byte                     ; definin tabulka KOI 8
         db        nofn+1,151               ; "u" se zptnou rkou
         db        nofn,138                 ; "e" se zptnou rkou
         db        nofn,21                  ; paragraf
         db        nofn,225                 ; beta
         db        nofn,156                 ; libra
         db        nofn,146                 ; "A" ve vichru
         db        nofn,237                 ; krtnut nekoneno
         db        nofn,143                 ; "A" s kroukem
         db        nofn,145                 ; "z" pokroucen
         db        nofn,237                 ; krtnut nekoneno
         db        nofn,134                 ; "a" s kroukem
         db        nofn+1,176               ; ""
         db        spc1,' '                 ; rubl
         db        nofn,149                 ; "o" se zptnou rkou
         db        nofn,141                 ; "i" se zptnou rkou
         db        nofn,158                 ; "Pt"
         db        nofn,173                 ; obrcen vykink
         db        nofn,165                 ; "N" s vlnovkou
         db        nofn,168                 ; obrcen otaznk
         db        nofn,164                 ; "n" s vlnovkou
         db        nofn,219                 ; ""
         db        nofn,220                 ; ""
         db        nofn,223                 ; ""
         db        nofn,186                 ; ""
         db        nofn,187                 ; ""
         db        nofn,188                 ; ""
         db        nofn,200                 ; ""
         db        nofn,201                 ; ""
         db        nofn,205                 ; ""
         db        nofn,177                 ; ""
         db        nofn,240                 ; ""
         db        nofn,241                 ; ""
         db        nofn,242                 ; ""
         db        nofn,243                 ; ""
         db        nofn,244                 ; ""
         db        nofn,245                 ; ""
         db        nofn,246                 ; ""
         db        nofn,247                 ; ""
         db        nofn,248                 ; ""
         db        nofn,251                 ; ""
         db        nofn,253                 ; ""
         db        nofn,171                 ; polovina
         db        nofn,172                 ; tvrtina
         db        nofn,21                  ; paragraf
         db        nofn+2,224               ; ""
         db        nofn,225                 ; ""
         db        nofn,226                 ; ""
         db        nofn,227                 ; ""
         db        nofn,228                 ; ""
         db        nofn,229                 ; ""
         db        nofn,230                 ; ""
         db        nofn,231                 ; ""
         db        nofn,232                 ; ""
         db        nofn,233                 ; ""
         db        nofn,234                 ; ""
         db        nofn,235                 ; ""
         db        nofn,236                 ; ""
         db        nofn,237                 ; ""
         db        nofn,238                 ; ""
         db        nofn,239                 ; ""
         db        nofn,218                 ; ""
         db        nofn,160                 ; ""
         db        nofn,192                 ; ""
         db        hacm,'c'                 ; "c" s hkem
         db        hacv,'d'                 ; "d" s hkem
         db        hacm,'e'                 ; "e" s hkem
         db        carm,'r'                 ; "r" s rkou
         db        nofn,196                 ; ""
         db        nofn,129                 ; ""
         db        nofn,161                 ; ""
         db        krom,'u'                 ; "u" s kroukem
         db        carp,'l'                 ; "l" s rkou
         db        hacp,'l'                 ; "l" s hkem
         db        nofn,148                 ; "o" s dvojtekou
         db        hacm,'n'                 ; "n" s hkem
         db        nofn,162                 ; "o" s rkou
         db        nofn,147                 ; "o" se stkou
         db        nofn,132                 ; "a" s dvojtekou
         db        hacm,'r'                 ; "r" s hkem
         db        hacm,'s'                 ; "s" s hkem
         db        hacp,'t'                 ; "t" s hkem
         db        nofn,163                 ; "u" s rkou
         db        nofn,195                 ; ""
         db        nofn,130                 ; "e" s rkou
         db        nofn,133                 ; "a" se zptnou rkou
         db        carm,'y'                 ; "y" s rkou
         db        hacm,'z'                 ; "z" s hkem
         db        nofn,194                 ; ""
         db        nofn,220                 ; ""
         db        nofn,223                 ; ""
         db        nofn,205                 ; ""
         db        nofn,197                 ; ""
         db        nofn,191                 ; ""
         db        carv,'A'                 ; "A" s rkou
         db        nofn,217                 ; ""
         db        hacv,'C'                 ; "C" s hkem
         db        hacv,'D'                 ; "D" s hkem
         db        hacv,'E'                 ; "E" s hkem
         db        carv,'R'                 ; "R" s rkou
         db        nofn,179                 ; ""
         db        nofn,154                 ; ""
         db        carv,'I'                 ; "I" s rkou
         db        krov,'U'                 ; "U" s kroukem
         db        carp,'L'                 ; "L" s rkou
         db        hacp,'L'                 ; "L" s hkem
         db        nofn,153                 ; "O" s dvojtekou
         db        hacv,'N'                 ; "N" s hkem
         db        carv,'O'                 ; "O" s rkou
         db        strv,'O'                 ; "O" se stkou
         db        nofn,142                 ; "A" s dvojtekou
         db        hacv,'R'                 ; "R" s hkem
         db        hacv,'S'                 ; "S" s hkem
         db        hacv,'T'                 ; "T" s hkem
         db        carv,'U'                 ; "U" s rkou
         db        nofn,180                 ; ""
         db        carv,'E'                 ; "E" s rkou
         db        zcarv,'A'                ; "A" se zptnou rkou
         db        carv,'Y'                 ; "Y" s rkou
         db        hacv,'Z'                 ; "Z s hkem
         db        nofn,193                 ; ""
         db        nofn,252                 ; ""
         db        nofn,250                 ; ""
         dw        0
TabKoi0  label     byte

; *****************************************************************************
;                         Instalace programu
; *****************************************************************************


Instal:  mov       ds:[SegRez],ds           ; segment tohoto programu

; ------ nalezen systmov promnn CSKOD

         mov       es,ds:[2ch]              ; segment prosted
         xor       di,di                    ; ukazatel prosted
         xor       al,al                    ; AL <- 0
Inst12:  cmp       byte ptr es:[di],0       ; konec prosted ?
         je        Inst19                   ; konec prosted
         mov       cx,6                     ; dlka textu CSKOD=
         mov       si,offset SetCSKod       ; text CSKOD=
         call      Srovnej                  ; porovnn textu
         je        Inst14                   ; promnn byla nalezena

; ------ nalezen dal promnn

         cld
         mov       ch,80h                   ; max. dlka = 32 KB
         repne     scasb                    ; nalezen dal promnn
         jmp       short Inst12             ; test dal promnn

; ------ rozlien nastavenho kdu

Inst14:  add       di,6                     ; adresa zatku parametru
         mov       si,offset SetKod         ; zatek tabulky kd
Inst16:  mov       cx,3                     ; dlka textu
         call      Srovnej                  ; porovnn text
         je        Inst18                   ; kd nalezen
         add       si,3                     ; dal kd
         inc       ax                       ; dal kd
         cmp       al,3                     ; maximln kd
         jbe       Inst16                   ; test dalho kdu
         jmp       short Inst19             ; kd nenalezen

; ------ kd byl nalezen

Inst18:  mov       byte ptr ds:[FontTab],al ; implicitn kd

; ------ test, zda je program ji nainstalovn, test karty EGA/VGA

Inst19:  push      cs
         pop       es
         mov       ah,12h                   ; funkce informac EGA
         mov       bx,3e10h                 ; podfunkce - test instalace
         int       10h                      ; informace o kart EGA
         cmp       bl,6                     ; kontrola navrcenho daje
         jb        Instal1                  ; je displej EGA/VGA

; ------ chyba - nen karta EGA/VGA

         mov       dx,offset ErrTxt         ; chyba - nen karta EGA/VGA
Chyba:   mov       ah,9
         int       21h
         int       20h

; ------ pprava k dekdovn pkazovho dku

Instal1: push      cs
         pop       ds                       ; DS <- CS
         mov       es,ds:[SegRez]           ; segment rezidentn sti
         mov       dx,offset Help           ; npovda
         mov       si,81h                   ; zatek textu
         xor       cx,cx
         mov       cl,ds:[si-1]             ; poet znak zadn
         cld                                ; smr nahoru

; ------ vyputn oddlova (mezer a tabeltor)

Instal3: jcxz      Instal6                  ; nen ji dal znak
         lodsb                              ; naten dalho znaku
         dec       cx                       ; snen tae znak
         cmp       al," "                   ; oddlovac znak ?
         jbe       Instal3                  ; je oddlovac znak - peskoen
         cmp       al,"/"
         je        Instal3                  ; oddlova parametr - vyputn
         or        al,20h                   ; pevod na mal psmeno

; ------ parametr /K - kd Kamenickch

         cmp       al,"k"                   ; kd Kamenickch ?
         jne       Instal4                  ; nen kd Kamenickch
         mov       byte ptr es:[FontTab],1  ; kd Kamenickch
         jmp       short Instal3            ; dal znak

; ------ parametr /L - kd Latin 2

Instal4: cmp       al,"l"                   ; kd Latin 2 ?
         jne       Instal5                  ; nen kd Latin 2
         mov       byte ptr es:[FontTab],2  ; kd Latin 2
         jmp       short Instal3            ; dal znak

; ------ parametr /I - kd KOI 8

Instal5: cmp       al,"i"                   ; kd KOI 8 ?
         jne       Instal52                 ; nen kd KOI 8
         mov       byte ptr es:[FontTab],3  ; kd KOI 8
         jmp       short Instal3            ; dal znak

; ------ parametr /0 - vypnut font

Instal52:cmp       al,"0"                   ; vypnut obsluhy ?
         jne       Instal53
         mov       byte ptr es:[FontTab],0  ; standardn kd IBM
         jmp       short Instal3            ; dal znak

; ------ parametr /! - odinstalovn z pamti

Instal53:cmp       al,"!"                   ; odinstalovn ?
         jne       Chyba                    ; chyba zadn
         mov       word ptr ds:[OdIns],1    ; pznak odinstalovn
         jmp       short Instal3

; ------ kontrola, zda je to prvn instalace

Instal6: mov       ax,cs
         cmp       ax,ds:[SegRez]           ; je program nainstalovan ?
         je        Instal7                  ; je to prvn instalace

; ------ nem-li bt odinstalovn pouze zobrazen informanho textu

         cmp       byte ptr ds:[OdIns],0    ; m bt odinstalovn ?
         je        Inst67                   ; nem bt odinstalovn - konec

; ------ kontrola, zda lze odinstalovat

         mov       ax,3510h                 ; funkce poskytnut INT 10h
         int       21h                      ; poskytnut adresy INT 10h
         mov       dx,offset ErrDIns        ; text - nelze odinstalovat
         cmp       bx,offset Int10          ; je offset INT 10h ?
         jne       Inst66                   ; chyba - nelze odinstalovat
         mov       ax,es                    ; segment INT 10h
         cmp       ax,ds:[SegRez]           ; je segment OK ?
         jne       Inst66                   ; nelze odinstalovat

; ------ nvrat vektoru peruen INT 10h

         mov       es,ds:[SegRez]           ; sezidentn segment
         push      ds
         lds       dx,es:[Old10]            ; pvodn adresa INT 10h
         mov       ax,2510h                 ; funkce nastaven vektoru peruen
         int       21h                      ; nvrat vektoru peruen INT 10h
         pop       ds

; ------ uvolnn segmentu pamti

         mov       ah,49h                   ; funkce uvolnn pamti
         int       21h                      ; uvolnn bloku pamti

; ------ hlen o odinstalovn programu

         mov       dx,offset DInsTxt        ; text - byl odinstalovn
Inst66:  mov       ah,9
         int       21h                      ; zobrazen textu
         int       20h                      ; konec programu

; ------ zobrazen informanho textu, konec

Inst67:  call      Inform                   ; zobrazen informanho textu
Inst68:  int       20h                      ; konec programu

; ------ prvn instalace - nelze odinstalovat

Instal7: mov       dx,offset ErrDIn2        ; text - nebyl nainstalovn
         cmp       byte ptr ds:[OdIns],0    ; poadovno odinstalovn ?
         jne       Inst66                   ; poadovno odinstalovn

; ------ zjitn adres systmovch font

         mov       di,offset Adrst8         ; adresy systmovch font
         mov       bh,3                     ; fonty 8x8
         call      DetFont                  ; detekce fontu 8x8
         mov       bh,2                     ; fonty 8x14
         call      DetFont                  ; detekce fontu 8x14
         mov       bh,6                     ; font 8x16
         call      DetFont                  ; detekce fontu 8x16
         mov       bh,8                     ; font 8x19
         call      DetFont                  ; detekce fontu 8x19
         mov       bh,12                    ; font 8x19 zvraznn
         call      DetFont                  ; detekce fontu 8x19 zvraz.

; ------ schova pvodn adresy INT 10h

         push      es
         mov       ax,3510h                 ; funkce poskytnut adresy INT 10h
         int       21h
         mov       word ptr ds:[Old10],bx   ; schova offsetu INT 10h
         mov       word ptr ds:[Old10+2],es ; schova segmentu INT 10h

; ------ instalace nov obsluhy INT 10h

         mov       dx,offset Int10          ; vlastn obsluha INT 10h
         mov       ax,2510h
         int       21h                      ; instalace vlastn obsluhy INT 10h

; ------ uvolnn pamovho bloku segmentu prosted

         mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h                   ; funkce uvolnn pamti
         int       21h                      ; uvolnn bloku pamti
         pop       es

; ------ zobrazen informanho textu

         call      Inform                   ; zobrazen informanho textu

; ------ instalace programu

         mov       dx,offset Instal         ; konec rezidentn sti
         int       27h                      ; instalace programu

; -----------------------------------------------------------------------------
;        porovnn vzoru s textem v prosted
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukazatel textu v prosted
;        DS:SI=ukazatel vzorovho textu (velk psmena)
;        CX=poet znak k porovnn
; VSTUP:ZY=text souhlas
; -----------------------------------------------------------------------------
; znien registry: CX
; -----------------------------------------------------------------------------

Srovnej  PROC      NEAR

; ------ schova registr

         push      ax
         push      si
         push      di

; ------ porovnn text

         cld
Srovn1:  mov       al,es:[di]               ; znak z prosted
         cmp       al,"a"
         jb        Srovn2                   ; nen mal psmeno
         cmp       al,"z"
         ja        Srovn2                   ; nen mal psmeno
         and       al,not 20h               ; korekce na velk psmeno
Srovn2:  cmp       al,ds:[si]               ; porovnn se vzorem
         jne       Srovn9                   ; nesouhlas
         inc       di
         inc       si
         loop      Srovn1                   ; porovnn dalho znaku
         cmp       al,al                    ; nastaven pznaku shody

; ------ nvrat registr

Srovn9:  pop       di
         pop       si
         pop       ax
         ret

Srovnej  ENDP

; -----------------------------------------------------------------------------
;        zobrazen informanho textu (ES=segment EGACSmin)
; -----------------------------------------------------------------------------

Inform   PROC      NEAR

; ------ stanoven adresy font

         xor       ax,ax
         mov       al,es:[FontTab]          ; slo tabulky font
         mov       si,offset TabKam         ; etina Kamenickch
         mov       cx,offset(TabKam0-TabKam) ; dlka tabulky
         dec       ax                       ; je etina Kamenickch ?
         jz        Inform1                  ; etina Kamenickch
         mov       si,offset TabLat         ; etina Latin 2
         mov       cx,offset(TabLat0-TabLat) ; dlka tabulky
         dec       ax                       ; je etina Latin 2 ?
         jz        Inform1                  ; je etina Latin 2
         mov       si,offset TabKoi         ; jinak KOI 8
         mov       cx,offset(TabKoi0-TabKoi) ; dlka tabulky

; ------ penos tabulky font

Inform1: cld
         mov       di,offset TabKoi
         rep       movsb                    ; penos tabulky

; ------ schova videomdu

         push      es                       ; segment aktivnho EGACSmin
         mov       ah,0fh
         int       10h                      ; dotaz na souasn videomd
         mov       cs:[OldVMod],al
         push      ax                       ; schova videomdu

; ------ schova pozice kurzoru

         mov       ah,3
         int       10h                      ; poskytnut pozice kurzoru
         pop       ax                       ; nvrat aktivnho videomdu
         push      dx                       ; schova pozice kurzoru

; ------ pedefinovn videomdu

         or        al,80h                   ; displej se nemae
         xor       ah,ah
         int       10h                      ; nov nastaven videomdu

; ------ zruen pznaku nemazat displej

         push      ds
         xor       ax,ax
         mov       ds,ax
         and       byte ptr ds:[449h],not 80h ; zruen pznaku nemazat displej
         and       byte ptr ds:[487h],not 80h ; zruen pznaku nemazat displej
         pop       ds

; ------ nvrat pozice kurzoru

         pop       dx                       ; nvrat pozice kurzoru
         mov       ah,2
         int       10h                      ; nvrat pozice kurzoru

; ------ pro LCD pedefinovn

         mov       ax,1130h
         mov       bl,4
         int       10h
         cmp       cx,19
         jne       Infor23
         mov       al,cs:[OldVMod]
         xor       ah,ah
         int       10h

; ------ zobrazen vodn sti informanho textu

Infor23: pop       es
         mov       dx,offset UvTxt          ; prvn st textu
         mov       ah,9
         int       21h                      ; zobrazen prvn sti textu

; ------ rozlien druh sti informanho textu

         xor       ax,ax
         mov       al,es:[FontTab]          ; slo tabulky font
         mov       dx,offset UvTxtK         ; etina Kamenickch
         dec       ax                       ; je etina Kamenickch ?
         jz        Inform2                  ; etina Kamenickch
         mov       dx,offset UvTxtL         ; etina Latin 2
         dec       ax                       ; je etina Latin 2 ?
         jz        Inform2                  ; je etina Latin 2
         mov       dx,offset UvTxtI         ; etina KOI 8
         dec       ax                       ; je etina KOI 8 ?
         jz        Inform2                  ; je etina KOI 8
         mov       dx,offset UvTxt0         ; etina vypnuta

; ------ zobrazen druh sti informanho textu

Inform2: mov       ah,9
         int       21h                      ; zobrazen druh sti textu
         ret

Inform   ENDP

; -----------------------------------------------------------------------------
;        detekce systmovho fontu
; -----------------------------------------------------------------------------
; VSTUP: BH=sluba ke zjitn ukazatele
;        ES:DI=ukldac adresa k uloen adresy
; VSTUP:ES:DI=nov ukldac adresa
; -----------------------------------------------------------------------------

DetFont  PROC      NEAR

; ------ zjitn adresy systmov tabulky font

         push      di
         push      es
         mov       ax,1130h
         int       10h                      ; informace o fontech
         mov       ax,es                    ; segment font
         pop       es
         pop       di

; ------ uloen zskan adresy font

         cld                                ; smr uloen nahoru
         xchg      ax,bp                    ; offset adresy
         stosw                              ; uloen offsetu adresy
         xchg      ax,bp                    ; segment adresy
         stosw                              ; uloen segmentu adresy
         ret

DetFont  ENDP

; -----------------------------------------------------------------------------
;        data instalan sti programu
; -----------------------------------------------------------------------------

OdIns    db        0                        ; 1=pznak odinstalovn

OldVMod  db        0

SetCSKod db        'CSKOD='
SetKod   db        'IBM'
         db        'KAM'
         db        'LAT'
         db        'KOI'

ErrTxt   db        'Neni karta EGA/VGA !',13,10,'$'

Help     db        'Zadejte:/K=Kamenickych',13,10
         db        9,'/L=Latin 2',13,10
         db        9,'/I=KOI 8',13,10
         db        9,'/0=IBM',13,10
         db        9,'/!=odinstalovani',13,10
         db        '$'

UvTxt    db        'EGACSmin V2.42 - CS fonty, $'
UvTxtK   db        'kd Kamenickch; (c) M.Nmeek',13,10,'$'
UvTxtL   db        'kd Latin 2; (c) M.Nmeek',13,10,'$'
UvTxtI   db        'kd KOI 8; (c) M.Nmeek',13,10,'$'
UvTxt0   db        'kd IBM; (c) M.Nemecek',13,10,'$'

DInsTxt  db        'EGACSmin byl odinstalovan.',13,10,'$'
ErrDIns  db        'EGACSmin nelze odinstalovat !',13,10,'$'
ErrDIn2  db        'EGACSmin nebyl dosud nainstalovan !',13,10,'$'

TabKam   label     byte                     ; definin tabulka Kamenickch

         db        hacv,'C'                 ; "C" s hkem
         db        carm+1,'e'               ; "e" s rkou
         db        hacv,'d'                 ; "d" s hkem
         db        hacv+1,'D'               ; "D" s hkem
         db        hacv,'T'                 ; "T" s hkem
         db        hacm,'c'                 ; "c" s hkem
         db        hacm,'e'                 ; "e" s hkem
         db        hacv,'E'                 ; "E" s hkem
         db        carp,'L'                 ; "L" s rkou
         db        carv,'I'                 ; "I" s rkou
         db        hacp,'l'                 ; "l" s hkem
         db        carp,'l'                 ; "l" s rkou
         db        carv+1,'A'               ; "A" s rkou
         db        carv,'E'                 ; "E" s rkou
         db        hacm,'z'                 ; "z" s hkem
         db        hacv,'Z'                 ; "Z" s hkem
         db        carv+2,'O'               ; "O" s rkou
         db        krom,'u'                 ; "u" s kroukem
         db        carv,'U'                 ; "U" s rkou
         db        carm,'y'                 ; "y" s rkou
         db        hacv+2,'S'               ; "S" s hkem
         db        hacp,'L'                 ; "L" s hkem
         db        carv,'Y'                 ; "Y" s rkou
         db        hacv,'R'                 ; "R" s hkem
         db        hacp,'t'                 ; "t" s hkem
         db        carm,'a'                 ; "a" s rkou
         db        carm+1,'o'               ; "o" s rkou
         db        carm,'u'                 ; "u" s rkou
         db        hacm,'n'                 ; "n" s hkem
         db        hacv,'N'                 ; "N" s hkem
         db        krov,'U'                 ; "U" s kroukem
         db        strv,'O'                 ; "O" se stkou
         db        hacm,'s'                 ; "s" s hkem
         db        hacm,'r'                 ; "r" s hkem
         db        carm,'r'                 ; "r" s rkou
         db        carv,'R'                 ; "R" s rkou
         db        nofn+1,21                ; paragraf
         dw        0

TabKam0  label     byte


TabLat   label     byte                     ; definin tabulka Latin 2

         db        carm+2,'e'               ; "e" s rkou
         db        krom+2,'u'               ; "u" s koukem
         db        carm,'c'                 ; "c" s rkou
         db        ocap,'c'                 ; "c" s ocskem
         db        skrs,'l'                 ; "l" pekrtnut
         db        dvov+1,'O'               ; "O" s dvojrkou
         db        dvom,'o'                 ; "o" s dvojrkou
         db        carv+1,'Z'               ; "Z" s rkou
         db        carv+1,'C'               ; "C" s rkou
         db        carv,'E'                 ; "E" s rkou
         db        carp,'L'                 ; "L" s rkou
         db        carp,'l'                 ; "l" s rkou
         db        hacp+2,'L'               ; "L" s hkem
         db        hacp,'l'                 ; "l" s hkem
         db        carv,'S'                 ; "S" s rkou
         db        carm,'s'                 ; "s" s rkou
         db        hacv+2,'T'               ; "T" s hkem
         db        hacp,'t'                 ; "t" s hkem
         db        skrl,'L'                 ; "L" pekrtnut
         db        nofn,'x'                 ; pekrtnut
         db        hacm,'c'                 ; "c" s hkem
         db        carm,'a'                 ; "a" s rkou
         db        carm+1,'o'               ; "o" s rkou
         db        carm,'u'                 ; "u" s rkou
         db        patr,'A'                 ; "A" s patikou
         db        pats,'a'                 ; "a" s patikou
         db        hacv,'Z'                 ; "Z" s hkem
         db        hacm,'z'                 ; "z" s hkem
         db        pats,'E'                 ; "E" s patikou
         db        pats,'e'                 ; "e" s patikou
         db        carm+1,'z'               ; "z" s rkou
         db        hacv,'C'                 ; "C" s hkem
         db        ocap,'s'                 ; "s" s ocskem
         db        carv+7,'A'               ; "A" s rkou
         db        strv,'A'                 ; "A" se stkou
         db        hacv,'E'                 ; "E" s hkem
         db        ocap,'S'                 ; "S" s ocskem
         db        tecv+4,'Z'               ; "Z" s tekou
         db        tecm,'z'                 ; "z" s tekou
         db        misv+7,'A'               ; "A" s miskou
         db        mism,'a'                 ; "a" s miskou
         db        spc1+7,' '               ; rubl
         db        skrp,'d'                 ; "d" pekrtnut
         db        skrl,'D'                 ; "D" pekrtnut
         db        hacv,'D'                 ; "D" s hkem
         db        dvot,'E'                 ; "E" dvojteka
         db        hacv,'d'                 ; "d" s hkem
         db        hacv,'N'                 ; "N" s hkem
         db        carv,'I'                 ; "I" s rkou
         db        strv,'I'                 ; "I" se stkou
         db        hacm,'e'                 ; "e" s hkem
         db        ocap+4,'T'               ; "T" s ocskem
         db        krov,'U'                 ; "U" s kroukem
         db        carv+1,'O'               ; "O" s rkou
         db        strv+1,'O'               ; "O" se stkou
         db        carv,'N'                 ; "N" s rkou
         db        carm,'n'                 ; "n" s rkou
         db        hacm,'n'                 ; "n" s hkem
         db        hacv,'S'                 ; "S" s hkem
         db        hacm,'s'                 ; "s" s hkem
         db        carv,'R'                 ; "R" s rkou
         db        carv,'U'                 ; "U" s rkou
         db        carm,'r'                 ; "r" s rkou
         db        dvov,'U'                 ; "U" s dvojrkou
         db        carm,'y'                 ; "y" s rkou
         db        carv,'Y'                 ; "Y" s rkou
         db        ocap,'t'                 ; "t" s ocskem
         db        carm,' '                 ; rka vpravo
         db        nofn,'-'                 ; pomlka
         db        dvom,' '                 ; dvojrka
         db        pats,' '                 ; patika
         db        hacm,' '                 ; hek
         db        mism,' '                 ; miska
         db        nofn,21                  ; paragraf
         db        ocap+1,' '               ; ocsek
         db        krom,' '                 ; krouek
         db        dvot,' '                 ; dvojteka
         db        dvom+1,'u'               ; "u" s dvojrkou
         db        hacv,'R'                 ; "R" s hkem
         db        hacm,'r'                 ; "r" s hkem
         dw        0

TabLat0  label     byte

Code     ENDS
         END       Start
